#include "mxframe.h"
#include <cwctype> 
#include <algorithm>

using namespace std;

vector<string> explode(const string& s, const char& c)
{
    string buff("");
    vector<string> v;

    for(auto n:s)
    {
        if(n != c) buff+=n; else
        if(n == c && buff != "") { v.push_back(buff); buff = ""; }
    }
    if(buff != "") v.push_back(buff);

    return v;
}

Color MxFrame::qp4strToColor(const string& str)
{
    uint32_t col;
    if (str.find("0x") == 0)
    {
        bool ok = false;
        col = stoul(str.substr(2).c_str(), nullptr, 16);
    }
    else {
        bool ok = false;
        col = stoul(str.c_str(), nullptr, 0);
    }
    uint8_t blue = (col >> 0) & 0xFF;
    uint8_t green = (col >> 8) & 0xFF;
    uint8_t red = (col >> 16) & 0xFF;
    uint8_t alpha = (col >> 24) & 0xFF;
    return Color(red, green, blue, alpha);
}

MxFrame::MxFrame()
{

}

vector<string> splitstr(const string& str, const string& delimiter)
{
    vector<string> strs;
    size_t pos = 0;
    size_t lastpos = 0;
    while ((pos = str.find(delimiter)) != std::string::npos) {
        strs.push_back(str.substr(lastpos, pos));
    }
    return strs;
}

// frame({pix1, pix2, ...},1000)
MxFrame::MxFrame(const string &import)
{
    int posBegin = import.find('{');
    int posEnd = import.find('}');
    string line = import.substr(posBegin+1, posEnd - posBegin-1);
    remove_if(line.begin(), line.end(), iswspace);
    vector<string> data = splitstr(line, ",");
//    QStringList data = line.split(',');
    for(int i = 0; i < data.size() && i < 26*32; i++)
    {
        int y = i / 32;
        int x = i % 32;
        pixels[y][x] = qp4strToColor(data[i]);
    }
    int lastcomma = import.rfind(',');
    int lastbracket = import.rfind(')');
    string alma = import.substr(lastcomma+1,lastbracket-lastcomma-1);
    this->length = stoul(import.substr(lastcomma+1,lastbracket-lastcomma-1).c_str(),nullptr,10);
}


