#include "spisender.h"
#include "wiringPi.h"
#include "wiringPiSPI.h"
#include <unistd.h>
#include <stdint.h>

SpiSender::SpiSender()
{
    wiringPiSetup();
    pinMode(readyPin, INPUT);
    pinMode(resetPin, OUTPUT);
    pullUpDnControl(readyPin, PUD_DOWN);
    digitalWrite(resetPin, LOW);
    usleep(100000);
    digitalWrite(resetPin, HIGH);
    usleep(100000);
    fd = wiringPiSPISetup(SPI_CHANNEL, SPI_SPEED);
    uint8_t dummy = 0;
    wiringPiSPIDataRW(SPI_CHANNEL, &dummy, 1);
}

SpiSender::~SpiSender()
{
    close(fd);
}

bool SpiSender::sendFrame(const SpiFrame &frame) const
{
    //while (!canSend());
    uint8_t dummy = 0;
    wiringPiSPIDataRW(SPI_CHANNEL, (uint8_t*)frame.data, 64*24*2);
    wiringPiSPIDataRW(SPI_CHANNEL, &dummy, 1);
    return true;
}

bool SpiSender::canSend() const
{
    return digitalRead(readyPin);
}

